

#include "..\00_hal\system.h"
#include "lcd.h"
#include "..\00_hal\lcd_hal.h"

//------------------------------------------------------------------------------
// LCD Function
//------------------------------------------------------------------------------
void LcdInit(void)
{
	lcd_hal_init();

    lcd_delay(LCD_DELAY+100);
    
    lcd_command(LCD_SET_SYSTEM | LCD_SYS_4BIT | LCD_SYS_2LINE);
    lcd_command(LCD_SET_CUR_SHIFT | LCD_DISPLAY_SHIFT | LCD_SURSOR_SHIFT_RIGHT);
    lcd_command(LCD_SET_DISPLAY | LCD_DISP_DISPLAY_ON);//| LCD_DISP_CURSOR_ON | LCD_DISP_CURSOR_FLASH);
	lcd_command(0x01);   
	lcd_command(LCD_CURSOR_HOME);
	
	lcd_delay(LCD_DELAY+3000);
	/*
    lcd_delay(LCD_DELAY+100);
    
    lcd_command(LCD_SET_SYSTEM | LCD_SYS_4BIT | LCD_SYS_2LINE);
    lcd_command(LCD_SET_CUR_SHIFT | LCD_DISPLAY_SHIFT | LCD_SURSOR_SHIFT_RIGHT);
    lcd_command(LCD_SET_DISPLAY | LCD_DISP_DISPLAY_ON);
	lcd_command(0x01);   
	lcd_command(LCD_CURSOR_HOME);*/	
}

void lcd_position(unsigned char x, unsigned char y)
{
	unsigned char address;

	if (y > 3)y = 3;
	if (x > 15)x = 15;

	switch(y)
	{
		case 0:
			address = 0x80;
			break;
			
		case 1:
			address = 0xC0;
			break;			
			
		case 2:
			address = 0x90;
			break;	
			
		case 3:
			address = 0xD0;
			break;
			
		default : address = 0x80;							
	}

	lcd_command(address+x);
}

void LcdClr(unsigned char line)
{
	switch(line)
	{
		case LINE_0:
			//               01234567
			LcdString(0, 0, "                ");		
			break;
			
		case LINE_1:
			//               01234567
			LcdString(0, 1, "                ");		
			break;			
			
		case LINE_ALL:
			lcd_command(LCD_CLEAR);		
			break;			
	}
	lcd_delay(LCD_DELAY+100);
}

void LcdChar(unsigned char x, unsigned char y, unsigned char ch)
{
	lcd_position(x, y);
	lcd_data(ch);
}

void LcdString(unsigned char x, unsigned char y, unsigned char *text)
{
	unsigned char i=0;

	lcd_position(x, y);

    for(i=0;i<16;i++)
    {
    	if(*(text+i)==0)break;
		
		lcd_data(*(text+i));  
    }
}
//end lcd
//------------------------------------------------------------------------------

