//#include "..\00_hal\system.h"
//#include "../00_hal/lcd_hal.h"

#ifndef __LCD_H_
#define __LCD_H_

#define LINE_0							0
#define LINE_1							1
#define LINE_ALL						2


//LCD Set System
#define LCD_SET_SYSTEM          0x20
#define LCD_SYS_8BIT            0x10
#define LCD_SYS_4BIT            0x00
#define LCD_SYS_2LINE           0x08

//LCD Set Cursor Shift
#define LCD_SET_CUR_SHIFT       0x10
#define LCD_DISPLAY_SHIFT       0x08    //if bit clear -> Cursor Shift 
#define LCD_SURSOR_SHIFT_RIGHT  0x04    //if bit clear -> Left Shift

//LCD Set Display
#define LCD_SET_DISPLAY         0x08
#define LCD_DISP_DISPLAY_ON     0x04
#define LCD_DISP_CURSOR_ON      0x02
#define LCD_DISP_CURSOR_FLASH   0x01

//LCD Set Input Mode
#define LCD_INPUT_MODE          0x04
#define LCD_INPUT_INCRENENT	    0x02    //if bit clear -> input decrement	
#define LCD_INPUT_SHIFT         0x01

#define LCD_CURSOR_HOME         0x02
#define LCD_CLEAR               0x01
#define LCD_SET_CGRAM           0x40
#define LCD_SET_DDRAM           0x80

#define LCD_DELAY				100



void LcdInit(void);
void LcdClr(unsigned char line);
void LcdString(unsigned char x, unsigned char y, unsigned char *text);

#endif
//end lcd
//------------------------------------------------------------------------------
