//=============================================================================
// Wiznet W5100 EVM Module Test Program
// by nexp76(nexp76@naver.com) http://cafe.naver.com/elab
//
// [tcp1.c]
//=============================================================================

/*
 - [W5100] EVM Tcp Clinent Test Program
 - MY_SOURCE_PORT(3000)  Ͽ   ø ǥ 
*/

#include <string.h>


#include "..\00_hal\system.h"
#include "..\01_drv\serial.h"

#include "../01_drv/wiznet/mcu/types.h"
#include "../01_drv/wiznet/iinchip/w5100.h"
#include "../01_drv/wiznet/iinchip/socket.h"
#include "../01_drv/wiznet/iinchip/wiznet.h"


//-----------------------------------------------------------------------------
/*
#define MY_NET_MAC			"\x00\x08\xDC\x00\x00\x00"		// MY Mac Address : 00.08.DC.00.00.00
#define MY_NET_SIP			0xC0A80004	// MY Source IP     : 192.168.0.4 	//  
#define MY_NET_SN			0xFFFFFF00	// MY Subnet Mask   : 255.255.255.0 // 
#define MY_NET_GWIP			0xC0A80001	// MY Gateway IP    : 192.168.0.1 	//  Ʈ
*/
#define MY_NET_MAC   {0x00, 0x08, 0xdc, 0x00, 0x00, 0x00} // MY Mac Address : 00.08.DC.00.00.00
#define MY_NET_GWIP   {192,  168, 0,    1} //Gateway     : 192.168.0.1
#define MY_NET_SIP   {192,  168, 0,  4} // IP     : 192.168.0.101
#define MY_NET_SN   {255, 255, 255,   0}


#define MY_CH_DESTIP		0xC0A80002	// MY Destination   : 192.168.0.2 	//   ǻ, 



#define MY_NET_DNS			0x00000000	// MY DNS Server IP : 0.0.0.0
#define MY_NET_MEMALLOC		0x55		// MY iinchip memory allocation

#define MY_LISTEN_PORT		5000		// MY Listen Port  : 5000 
#define MY_CONNECT_PORT		3000		// MY Connect Port : 3000
#define MY_SOURCE_PORT		3000		// MY Source Port  : 3000

#define TX_RX_MAX_BUF_SIZE	2048
#define SOCK_TCPC			1
#define SOCK_TCPS			0
//-----------------------------------------------------------------------------



//-----------------------------------------------------------------------------
#define HTONL				_htonl

u_long _htonl(u_long l)
{
	u_long ret=0;
	ret = (l & 0xFF) << 24;
	ret |= ((l >> 8) & 0xFF) << 16;
	ret |= ((l >> 16) & 0xFF) << 8;
	ret |= ((l >> 24) & 0xFF);
	return ret;
}

//-----------------------------------------------------------------------------
// Main Routine
//-----------------------------------------------------------------------------
int main(void)
{
	SystemInit();
	
	//Serial Init
	DebugInit(BAUD_115200);
	DebugPrint("Wiznet W5100 Test Program..\r\n");

	//W5100 Chip Initialize
	//----------------------------
	InitWiznet();

	NetInit();
	//----------------------------
	
	//Display Net Configuration..
	DisplayConfig();


	while (1)
	{
		// TCP Client Process		
		
		//ProcessTcpClient();
		ProcessTcpSever();
	}		
}
//-----------------------------------------------------------------------------

void NetInit(void)
{
/*
	u_char mac[6];
	unsigned long ip;
	memcpy(mac, MY_NET_MAC, 6);
	
	iinchip_init();

	ip = HTONL(MY_NET_SIP);		setSIPR((u_char*)&ip);	
	ip = HTONL(MY_NET_GWIP);	setGAR((u_char*)&ip);
	ip = HTONL(MY_NET_SN);		setSUBR((u_char*)&ip);


	setSHAR(mac); //  巹 
	
	{
		ip = HTONL(MY_CH_DESTIP);
		printf("Destination IP: %s. (%s)", ip, MY_CH_DESTIP);
	}

#ifdef __DEF_IINCHIP_INT__
	setIMR(0xEF);
#endif
	
	sysinit(MY_NET_MEMALLOC, MY_NET_MEMALLOC);
	*/

	unsigned char mac[6] = MY_NET_MAC;
	unsigned char sm[4] = MY_NET_SN;
	unsigned char gwip[4] = MY_NET_GWIP;
	unsigned char m_sip[4] = MY_NET_SIP;

	// IICHIP_HAL_INIT();
	// IICHIP_RESET_INIT() ;
	//  IICHIP_RESET();

	DebugPrint("W5100_NetInit");     

	//W5100 Chip Init
	iinchip_init();

	//Set MAC Address
	setSHAR(mac);

	//Set Gateway
	setGAR(gwip);

	//Set Subnet Mask
	setSUBR(sm); // 2015.04.22  
	applySUBR(); //             

	//Set My IP
	setSIPR(m_sip);

	#ifdef __DEF_IINCHIP_INT__
	setIMR(0xEF);
	#endif

	sysinit(MY_NET_MEMALLOC, MY_NET_MEMALLOC);  
}
//-----------------------------------------------------------------------------



//-----------------------------------------------------------------------------

/*
//TCP-Client ó
void ProcessTcpClient(void)
{
	unsigned int len;							
	unsigned char data_buf[TX_RX_MAX_BUF_SIZE];
	unsigned long server_ip = HTONL(MY_CH_DESTIP);
	unsigned long port = MY_CONNECT_PORT;
	
	switch (getSn_SR(SOCK_TCPC))
	{
		case SOCK_ESTABLISHED: // 
			DebugPrint("SOCK_ESTABLISHED");
			if(m_SokStatus1==1)
			{
				m_SokStatus1 = 2;
			}
		
			//check Rx data
			if((len = getSn_RX_RSR(SOCK_TCPC)) > 0) 			
			{
				//if Rx data size is lager than TX_RX_MAX_BUF_SIZE 
				if (len > TX_RX_MAX_BUF_SIZE) len = TX_RX_MAX_BUF_SIZE;	
				//read the received data
				len = recv(SOCK_TCPC, data_buf, len);			

				//send the received data - loop back test
				send(SOCK_TCPC, data_buf, len);	


				//Debug serial print
				EthernetTest(data_buf, len);
			}
			break;
		
		case SOCK_CLOSE_WAIT:                           		
			//If the client request to close
			DebugPrint("SOCK_CLOSE_WAIT, disconnect");
			disconnect(SOCK_TCPC);
		
			m_SokStatus1 = 0;
			break;
		
		case SOCK_CLOSED:
			//if a socket is closed
			if(!m_SokStatus1)
			{
				DebugPrint("TCP Client Started!\r\n");
				m_SokStatus1 = 1;
			}

			//reinitialize the socket
			if(socket(SOCK_TCPC, Sn_MR_TCP, port, 0x00) == 0)    
			{
				DebugPrint("socket open error");
				m_SokStatus1 = 0;
			}
			else
			{	
				if(server_ip == NULL)
				{
					printf("not server ip\r\n");
					break;
				}
				connect(SOCK_TCPC, (unsigned char*)&server_ip, port);
				printf("ServerIp : %s, port : %d\r\n", server_ip, port);
			}		
			break;
	}	
}
*/
//-----------------------------------------------------------------------------

//ŵ ó
void EthernetTest(unsigned char *pRcvBuffer, unsigned int len)
{
	unsigned int i;
	DebugPrint("Read Data[%d]\r\n", len);
	
	for(i=0;i<len;i++)
	{
		//if(i%16==0)DebugPrint("\r\n");
		DebugPrint("%c", pRcvBuffer[i]);
	}
	DebugPrint("\r\nSend OK-!\r\n");
}


int m_state = 0;
// -----------------------------------------------------------------------------
// 2) 
//  Ŭ̾Ʈ     socket()Լ    listen()Լ
// κ  ٸ ȴ.
// Initialize socket -    ʱȭ
unsigned char InitSocketServer(unsigned int Socket, unsigned Port)
{
	//initialize the socket 
	if(socket(Socket,Sn_MR_TCP, Port,0x00) == 0)
	{
		DebugPrint("Fail to create socket.");
		return 0;
	}
	else
	{
		listen(Socket);
		printf("listen...");
	}

	return 1;
}




//TCP-Server ó
void ProcessTcpSever(void)
{
	unsigned int len;							
	unsigned char data_buf[TX_RX_MAX_BUF_SIZE];
	uint16 port = MY_LISTEN_PORT;

	
	char send_data_buf[1024] = {0x00,};
	
	switch (getSn_SR(SOCK_TCPS))
	{
	case SOCK_ESTABLISHED: //  
		//check Rx data
		if((len = getSn_RX_RSR(SOCK_TCPS)) > 0)    
		   {
		       if (len > TX_RX_MAX_BUF_SIZE) 
			   		len = TX_RX_MAX_BUF_SIZE; 
		       // 

				len = recv(SOCK_TCPS, data_buf, len);   

				printf("recvData ....%s \r\n", data_buf);

				sprintf((uint8*)send_data_buf, (uint8*)"%-1024s", "111112");
				//ŵ ó-> 
				send(SOCK_TCPS, (uint8*)&send_data_buf, strlen(send_data_buf));    
				//send(SOCK_TCPS, "111", 1024);    
		   }  	
		break;
		
	case SOCK_CLOSE_WAIT:         
		//If the client request to close
		printf(">>> disconnet\r\n");
		disconnect(SOCK_TCPS);
		break;
		
	case SOCK_CLOSED:
		//if a socket is closed
		//reinitialize the socket 
		InitSocketServer(SOCK_TCPS, port);
		break;


	}
}
//-----------------------------------------------------------------------------





